diff -rNci gcc-2.7.2/reload1.c gcc-2.7.2p/reload1.c
*** gcc-2.7.2/reload1.c	Sun Nov  5 16:22:22 1995
--- gcc-2.7.2p/reload1.c	Tue Jan 23 09:25:31 1996
***************
*** 34,40 ****
  #include "recog.h"
  #include "basic-block.h"
  #include "output.h"
- #include "real.h"
  
  /* This file contains the reload pass of the compiler, which is
     run after register allocation has been done.  It checks that
--- 34,39 ----
***************
*** 77,82 ****
--- 76,83 ----
  #ifndef MEMORY_MOVE_COST
  #define MEMORY_MOVE_COST(x) 4
  #endif
+ /* intel1 */
+ static int cur_stack_offset;
  
  /* During reload_as_needed, element N contains a REG rtx for the hard reg
     into which reg N has been reloaded (perhaps for a previous insn). */
***************
*** 268,273 ****
--- 269,277 ----
  #define obstack_chunk_alloc xmalloc
  #define obstack_chunk_free free
  
+ /* intel1 */
+ extern FILE * global_reg_dump_file;
+ 
  /* List of labels that must never be deleted.  */
  extern rtx forced_labels;
  
***************
*** 308,313 ****
--- 312,326 ----
  
  #define NUM_ELIMINABLE_REGS (sizeof reg_eliminate / sizeof reg_eliminate[0])
  
+ /* intel1 */
+ /* information for loop_after_global optimizations */
+ struct reload_slot_info reload_slots[MAX_RELOAD_STACK_SLOTS];
+ int num_reload_stack_slots=0;
+ static rtx treplace_insn = NULL_RTX;
+ 
+ /* is 1 is the pseudo has been spilled */
+ int * pseudo_spilled;
+ 
  /* Record the number of pending eliminations that have an offset not equal
     to their initial offset.  If non-zero, we use a new copy of each
     replacement result in any insns encountered.  */
***************
*** 372,377 ****
--- 385,392 ----
  static void inc_for_reload		PROTO((rtx, rtx, int));
  static int constraint_accepts_reg_p	PROTO((char *, rtx));
  static int count_occurrences		PROTO((rtx, rtx));
+ /* intel1 */
+ int is_a_param_slot();
  
  /* Initialize the reload pass once per compilation.  */
  
***************
*** 466,471 ****
--- 481,506 ----
    /* The basic block number currently being processed for INSN.  */
    int this_block;
  
+   /* intel1 */
+   /* intel1. Look for insns whose src is equal to dest and delete them.  */
+   for (insn = next_nonnote_insn (first); insn; insn = next_nonnote_insn (insn))
+     {
+       if (GET_CODE (insn) == INSN 
+           && GET_CODE (PATTERN (insn)) == SET
+           && !(GET_CODE (SET_SRC (PATTERN (insn))) == MEM
+                && MEM_VOLATILE_P (SET_SRC (PATTERN (insn))))
+           && rtx_equal_p (SET_SRC (PATTERN (insn)), SET_DEST (PATTERN (insn))))
+         {
+ 	  PUT_CODE (insn, NOTE);
+ 	  NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+ 	  NOTE_SOURCE_FILE (insn) = 0;
+         }
+     }
+   num_reload_stack_slots = 0;
+   pseudo_spilled = (int *)alloca(max_regno*sizeof(int));
+   bzero(pseudo_spilled,max_regno*sizeof(int));
+   bzero(reload_slots,MAX_RELOADS*sizeof(struct reload_slot_info));
+ 
    /* Make sure even insns with volatile mem refs are recognizable.  */
    init_recog ();
  
***************
*** 814,819 ****
--- 849,857 ----
  
        num_not_at_initial_offset = 0;
  
+ 	  /* intel1 */
+ 	  cur_stack_offset = 0;
+ 
        bzero ((char *) &offsets_known_at[get_first_label_num ()], num_labels);
  
        /* Set a known offset for each forced label to be at the initial offset
***************
*** 1955,1960 ****
--- 1993,2034 ----
  
    reload_in_progress = 0;
  
+   /* intel1 */
+   for (insn = first; insn; insn = NEXT_INSN (insn))
+     {
+       if (GET_CODE (insn) == INSN && GET_CODE (PATTERN (insn)) == SET
+           && GET_CODE (SET_DEST (PATTERN (insn))) == REG
+           && GET_CODE (SET_SRC (PATTERN (insn))) == REG)
+         {
+           if (REGNO (SET_DEST (PATTERN (insn))) < FIRST_PSEUDO_REGISTER
+               && REGNO (SET_SRC (PATTERN (insn))) >= FIRST_PSEUDO_REGISTER
+               && reg_equiv_mem[REGNO (SET_SRC (PATTERN (insn)))]
+               && reg_renumber[REGNO (SET_SRC (PATTERN (insn)))] < 0
+               && RTX_IS_SPILL_P (reg_equiv_mem[REGNO (SET_SRC (PATTERN (insn)))])
+               && !RTX_IS_SPILL_P (insn))
+             {
+               RTX_IS_SPILL_P (insn) = 1;
+               SPILL_PSEUDO (insn) = REGNO (SET_SRC (PATTERN (insn)));
+             }
+           if (REGNO (SET_DEST (PATTERN (insn))) >= FIRST_PSEUDO_REGISTER
+               && REGNO (SET_SRC (PATTERN (insn))) < FIRST_PSEUDO_REGISTER
+               && reg_equiv_mem[REGNO (SET_DEST (PATTERN (insn)))]
+               && reg_renumber[REGNO (SET_DEST (PATTERN (insn)))] < 0
+               && RTX_IS_SPILL_P (reg_equiv_mem[REGNO (SET_DEST (PATTERN (insn)))])
+               && !RTX_IS_SPILL_P (insn))
+             {
+               RTX_IS_SPILL_P (insn) = 1;
+               SPILL_PSEUDO (insn) = REGNO (SET_DEST (PATTERN (insn)));
+             }
+   if (scratch_list)
+     free (scratch_list);
+   scratch_list = 0;
+   if (scratch_block)
+     free (scratch_block);
+   scratch_block = 0;
+ 
+         }
+     }
    /* Now eliminate all pseudo regs by modifying them into
       their equivalent memory references.
       The REG-rtx's for the pseudos are modified in place,
***************
*** 2016,2028 ****
    reg_equiv_constant = 0;
    reg_equiv_memory_loc = 0;
  
!   if (scratch_list)
!     free (scratch_list);
!   scratch_list = 0;
!   if (scratch_block)
!     free (scratch_block);
!   scratch_block = 0;
! 
    return failure;
  }
  
--- 2090,2106 ----
    reg_equiv_constant = 0;
    reg_equiv_memory_loc = 0;
  
!   /* intel1 */
!   if (num_reload_stack_slots == MAX_RELOAD_STACK_SLOTS)
!     { /* Too many so don't use any */
!       for (insn = first; insn ; insn = next_nonnote_insn (insn))
!         {
!           if (GET_CODE (insn) == INSN )
!             {
!               RTX_IS_SPILL_P (insn) = 0;
!             }
!         }
!     }
    return failure;
  }
  
***************
*** 2325,2330 ****
--- 2403,2417 ----
    REGNO (regno_reg_rtx[i])
      = reg_renumber[i] >= 0 ? reg_renumber[i] : i;
  
+   /* intel1 */
+   if (reg_renumber[i] < 0 
+       && reg_equiv_memory_loc[i] != 0
+       && is_a_param_slot (reg_equiv_memory_loc[i]))
+     {
+       pseudo_spilled[i] = 1;
+       RTX_IS_SPILL_P (reg_equiv_memory_loc[i]) = 1;
+       RTX_IS_SPILL_P (XEXP (reg_equiv_memory_loc[i], 0)) = 1;
+     }
    /* If we have a pseudo that is needed but has no hard reg or equivalent,
       allocate a stack slot for it.  */
  
***************
*** 2338,2343 ****
--- 2425,2432 ----
        int total_size = MAX (inherent_size, reg_max_ref_width[i]);
        int adjust = 0;
  
+       /* intel1 */
+       pseudo_spilled[i] = 1;
        /* Each pseudo reg has an inherent size which comes from its own mode,
  	 and a total size which provides room for paradoxical subregs
  	 which refer to the pseudo reg in wider modes.
***************
*** 2350,2362 ****
  	{
  	  /* No known place to spill from => no slot to reuse.  */
  	  x = assign_stack_local (GET_MODE (regno_reg_rtx[i]), total_size, -1);
  	  if (BYTES_BIG_ENDIAN)
  	    /* Cancel the  big-endian correction done in assign_stack_local.
  	       Get the address of the beginning of the slot.
  	       This is so we can do a big-endian correction unconditionally
  	       below.  */
  	    adjust = inherent_size - total_size;
- 
  	  RTX_UNCHANGING_P (x) = RTX_UNCHANGING_P (regno_reg_rtx[i]);
  	}
        /* Reuse a stack slot if possible.  */
--- 2439,2453 ----
  	{
  	  /* No known place to spill from => no slot to reuse.  */
  	  x = assign_stack_local (GET_MODE (regno_reg_rtx[i]), total_size, -1);
+ 	  /* intel1 */
+ 	  RTX_IS_SPILL_P (x) = 1;
+ 	  RTX_IS_SPILL_P (XEXP (x, 0)) = 1;
  	  if (BYTES_BIG_ENDIAN)
  	    /* Cancel the  big-endian correction done in assign_stack_local.
  	       Get the address of the beginning of the slot.
  	       This is so we can do a big-endian correction unconditionally
  	       below.  */
  	    adjust = inherent_size - total_size;
  	  RTX_UNCHANGING_P (x) = RTX_UNCHANGING_P (regno_reg_rtx[i]);
  	}
        /* Reuse a stack slot if possible.  */
***************
*** 2364,2370 ****
--- 2455,2463 ----
  	       && spill_stack_slot_width[from_reg] >= total_size
  	       && (GET_MODE_SIZE (GET_MODE (spill_stack_slot[from_reg]))
  		   >= inherent_size))
+         {
  	x = spill_stack_slot[from_reg];
+  	}
        /* Allocate a bigger slot.  */
        else
  	{
***************
*** 2383,2400 ****
  	  /* Make a slot with that size.  */
  	  x = assign_stack_local (mode, total_size, -1);
  	  stack_slot = x;
  	  if (BYTES_BIG_ENDIAN)
  	    {
  	      /* Cancel the  big-endian correction done in assign_stack_local.
! 		 Get the address of the beginning of the slot.
! 		 This is so we can do a big-endian correction unconditionally
! 		 below.  */
  	      adjust = GET_MODE_SIZE (mode) - total_size;
! 	      if (adjust)
! 		stack_slot = gen_rtx (MEM, mode_for_size (total_size
! 							  * BITS_PER_UNIT,
! 							  MODE_INT, 1),
! 				      plus_constant (XEXP (x, 0), adjust));
  	    }
  	  spill_stack_slot[from_reg] = stack_slot;
  	  spill_stack_slot_width[from_reg] = total_size;
--- 2476,2496 ----
  	  /* Make a slot with that size.  */
  	  x = assign_stack_local (mode, total_size, -1);
  	  stack_slot = x;
+ 	  /* intel1 */
+ 	  RTX_IS_SPILL_P (x) = 1;
+ 	  RTX_IS_SPILL_P (XEXP (x, 0)) = 1;
  	  if (BYTES_BIG_ENDIAN)
  	    {
  	      /* Cancel the  big-endian correction done in assign_stack_local.
! 	         Get the address of the beginning of the slot.
! 	         This is so we can do a big-endian correction unconditionally
! 	         below.  */
  	      adjust = GET_MODE_SIZE (mode) - total_size;
! 	      if(adjust)
! 	        stack_slot = gen_rtx (MEM, mode_for_size (total_size
! 	                         * BITS_PER_UNIT,
! 	                         MODE_INT, 1),
! 	                         plus_constant (XEXP (x, 0), adjust));
  	    }
  	  spill_stack_slot[from_reg] = stack_slot;
  	  spill_stack_slot_width[from_reg] = total_size;
***************
*** 2412,2417 ****
--- 2508,2516 ----
  	  x = gen_rtx (MEM, GET_MODE (regno_reg_rtx[i]),
  		       plus_constant (XEXP (x, 0), adjust));
  	  RTX_UNCHANGING_P (x) = RTX_UNCHANGING_P (regno_reg_rtx[i]);
+ 	  /* intel1 */
+ 	  RTX_IS_SPILL_P (x) = 1;
+ 	  RTX_IS_SPILL_P (XEXP (x, 0)) = 1;
  	}
  
        /* Save the stack slot for later.   */
***************
*** 2650,2655 ****
--- 2749,2756 ----
    int i, j;
    char *fmt;
    int copied = 0;
+   /* intel1 */
+   int indx;
  
    switch (code)
      {
***************
*** 2699,2704 ****
--- 2800,2823 ----
  	     address in case it is shared.  */
  	  new = eliminate_regs (reg_equiv_memory_loc[regno],
  				mem_mode, insn);
+ 	  /* intel1 */
+ 	  if ((flag_loop_after_global || flag_peep_spills)
+ 	      && treplace_insn && is_a_stack_slot (new) 
+ 	      && !is_a_reload_stack_slot (new, &indx, cur_stack_offset, treplace_insn)
+ 	      && num_reload_stack_slots < MAX_RELOAD_STACK_SLOTS)
+ 	    {
+               if (num_reload_stack_slots < MAX_RELOAD_STACK_SLOTS)
+                 {
+ 	          reload_slots[num_reload_stack_slots].cur_stack_offset 
+ 	            = cur_stack_offset;
+ 	          reload_slots[num_reload_stack_slots].stack_slot_pseudo_reg 
+ 		    = regno;
+ 	          reload_slots[num_reload_stack_slots].reload_stack_slot 
+ 		    = new;
+ 	          reload_slots[num_reload_stack_slots++].reload_insn
+ 		    = treplace_insn;
+ 		}
+ 	    }
  	  if (new != reg_equiv_memory_loc[regno])
  	    {
  	      cannot_omit_stores[regno] = 1;
***************
*** 3094,3103 ****
--- 3213,3226 ----
        new = eliminate_regs (XEXP (x, 0), GET_MODE (x), insn);
        if (new != XEXP (x, 0))
  	{
+ 	  /* intel1 */
+ 	  new->is_spill_rtx = x->is_spill_rtx;
  	  new = gen_rtx (MEM, GET_MODE (x), new);
  	  new->volatil = x->volatil;
  	  new->unchanging = x->unchanging;
  	  new->in_struct = x->in_struct;
+ 	  /* intel1 */
+ 	  new->is_spill_rtx = x->is_spill_rtx;
  	  return new;
  	}
        else
***************
*** 3236,3242 ****
  	       will delete it in reload_as_needed once we know that this
  	       elimination is, in fact, being done.
  
! 	       If REPLACE isn't set, we can't delete this insn, but needn't
  	       process it since it won't be used unless something changes.  */
  	    if (replace)
  	      delete_dead_insn (insn);
--- 3359,3365 ----
  	       will delete it in reload_as_needed once we know that this
  	       elimination is, in fact, being done.
  
! 	       If REPLACE isn't set, we can't delete this insn, but neededn't
  	       process it since it won't be used unless something changes.  */
  	    if (replace)
  	      delete_dead_insn (insn);
***************
*** 3288,3295 ****
--- 3411,3422 ----
       re-recognize the insn.  We do this in case we had a simple addition
       but now can do this as a load-address.  This saves an insn in this
       common case. */
+   /* intel1 */
+   treplace_insn = replace ? insn : NULL_RTX;
  
    new_body = eliminate_regs (old_body, 0, replace ? insn : NULL_RTX);
+   /* intel1 */
+   treplace_insn = NULL_RTX;
    if (new_body != old_body)
      {
        /* If we aren't replacing things permanently and we changed something,
***************
*** 3806,3812 ****
  	{
  	  rtx avoid_return_reg = 0;
  	  rtx oldpat = PATTERN (insn);
- 
  #ifdef SMALL_REGISTER_CLASSES
  	  /* Set avoid_return_reg if this is an insn
  	     that might use the value of a function call.  */
--- 3933,3938 ----
***************
*** 3961,3966 ****
--- 4087,4102 ----
  		  forget_old_reloads_1 (XEXP (x, 0), NULL_RTX);
  	      }
  #endif
+           /* intel1 */
+ 	  if (GET_CODE (PATTERN (insn)) == PARALLEL)
+ 	    {
+ 	      int i;
+ 	      for (i = 0; i < XVECLEN (PATTERN (insn), 0); i++)
+ 		update_stack_offset (XVECEXP (PATTERN (insn), 0, i), 
+ 		                     &cur_stack_offset);
+ 	    }
+ 	  else
+ 	    update_stack_offset (PATTERN (insn), &cur_stack_offset);
  	}
        /* A reload reg's contents are unknown after a label.  */
        if (GET_CODE (insn) == CODE_LABEL)
***************
*** 5650,5661 ****
    rtx output_address_reload_insns[MAX_RECOG_OPERANDS];
    rtx operand_reload_insns = 0;
    rtx other_operand_reload_insns = 0;
-   rtx other_output_reload_insns = 0;
    rtx following_insn = NEXT_INSN (insn);
    rtx before_insn = insn;
    int special;
    /* Values to be put in spill_reg_store are put here first.  */
    rtx new_spill_reg_store[FIRST_PSEUDO_REGISTER];
  
    for (j = 0; j < reload_n_operands; j++)
      input_reload_insns[j] = input_address_reload_insns[j]
--- 5786,5798 ----
    rtx output_address_reload_insns[MAX_RECOG_OPERANDS];
    rtx operand_reload_insns = 0;
    rtx other_operand_reload_insns = 0;
    rtx following_insn = NEXT_INSN (insn);
    rtx before_insn = insn;
    int special;
    /* Values to be put in spill_reg_store are put here first.  */
    rtx new_spill_reg_store[FIRST_PSEUDO_REGISTER];
+   int indx; /* intel1 */
+   rtx tmp_stack_slot, reload_insn; /* intel1 */
  
    for (j = 0; j < reload_n_operands; j++)
      input_reload_insns[j] = input_address_reload_insns[j]
***************
*** 6054,6062 ****
  					   third_reload_reg)));
  			    }
  			  else
  			    gen_reload (second_reload_reg, oldequiv,
  					reload_opnum[j],
! 					reload_when_needed[j]);
  
  			  oldequiv = second_reload_reg;
  			}
--- 6191,6231 ----
  					   third_reload_reg)));
  			    }
  			  else
+               /* intel1 */
+               reload_insn =
  			    gen_reload (second_reload_reg, oldequiv,
  					reload_opnum[j],
! 			reload_when_needed[j]);
!              /* intel1 */
!              if ((flag_loop_after_global ||flag_peep_spills) 
!                &&is_a_reload_stack_slot(oldequiv,&indx,cur_stack_offset,NULL))
!               {
!                  RTX_IS_SPILL_P (reload_insn) = 1;
!                  if (indx == -1)
!                  {
!                     tmp_stack_slot
!                      = eliminate_regs (
!                      reg_equiv_memory_loc[REGNO (oldequiv)],
!                      GET_MODE (oldequiv), NULL_RTX);
! 
!                      if (num_reload_stack_slots < MAX_RELOAD_ STACK_SLOTS
!                      && !is_a_reload_stack_slot (tmp_stack_slot, &indx, cur_stack_offset, NULL))
!                      {
!                         reload_slots[num_reload_stack_slots].cur_stack_offset
!                            = cur_stack_offset;
!                       reload_slots[num_reload_stack_slots].stack_slot_pseudo_reg
!                            = REGNO (oldequiv);
!                           reload_slots[num_reload_stack_slots].reload_stack_slot
!                            = tmp_stack_slot;
!                            reload_slots[num_reload_stack_slots++].reload_insn
!                            = NULL;
!                       }
!                          SPILL_PSEUDO (reload_insn) = REGNO (oldequiv);
!                     }
!                      else
!                         SPILL_PSEUDO (reload_insn)
!                          = reload_slots[indx].stack_slot_pseudo_reg;
!                   }
  
  			  oldequiv = second_reload_reg;
  			}
***************
*** 6065,6072 ****
  #endif
  
  	      if (! special && ! rtx_equal_p (reloadreg, oldequiv))
! 		gen_reload (reloadreg, oldequiv, reload_opnum[j],
  			    reload_when_needed[j]);
  
  #if defined(SECONDARY_INPUT_RELOAD_CLASS) && defined(PRESERVE_DEATH_INFO_REGNO_P)
  	      /* We may have to make a REG_DEAD note for the secondary reload
--- 6234,6271 ----
  #endif
  
  	      if (! special && ! rtx_equal_p (reloadreg, oldequiv))
! 		  /* intel1 */
! 		reload_insn = gen_reload (reloadreg, oldequiv, reload_opnum[j],
  			    reload_when_needed[j]);
+       /* intel1 */ if ((flag_loop_after_global || flag_peep_spills)
+            && is_a_reload_stack_slot (oldequiv, &indx, cur_stack_offset, NULL))
+           {
+            RTX_IS_SPILL_P (reload_insn) = 1;
+            if (indx == -1)
+              {
+                tmp_stack_slot
+                  = eliminate_regs (
+                  reg_equiv_memory_loc[REGNO (oldequiv)],
+                  GET_MODE (oldequiv), NULL_RTX);
+ 
+                   if (num_reload_stack_slots < MAX_RELOAD_STACK_SLOTS
+                      && !is_a_reload_stack_slot (tmp_stack_slot, &indx, cur_stack_offset, NULL))
+                   {
+                      reload_slots[num_reload_stack_slots].cur_stack_offset
+                       = cur_stack_offset;
+                      reload_slots[num_reload_stack_slots].stack_slot_pseudo_reg
+                       = REGNO (oldequiv);
+                        reload_slots[num_reload_stack_slots].reload_stack_slot 
+                       = tmp_stack_slot;
+                         reload_slots[num_reload_stack_slots++].reload_insn
+                       = NULL;
+                   }
+                     SPILL_PSEUDO (reload_insn) = REGNO (oldequiv);
+               }
+             else
+               SPILL_PSEUDO (reload_insn)
+                 = reload_slots[indx].stack_slot_pseudo_reg;
+           }
  
  #if defined(SECONDARY_INPUT_RELOAD_CLASS) && defined(PRESERVE_DEATH_INFO_REGNO_P)
  	      /* We may have to make a REG_DEAD note for the secondary reload
***************
*** 6260,6275 ****
  	      XEXP (note, 0) = reload_reg_rtx[j];
  	      continue;
  	    }
- 	  /* Likewise for a SUBREG of an operand that dies.  */
- 	  else if (GET_CODE (old) == SUBREG
- 		   && GET_CODE (SUBREG_REG (old)) == REG
- 		   && 0 != (note = find_reg_note (insn, REG_UNUSED,
- 						  SUBREG_REG (old))))
- 	    {
- 	      XEXP (note, 0) = gen_lowpart_common (GET_MODE (old),
- 						   reload_reg_rtx[j]);
- 	      continue;
- 	    }
  	  else if (GET_CODE (old) == SCRATCH)
  	    /* If we aren't optimizing, there won't be a REG_UNUSED note,
  	       but we don't want to make an output reload.  */
--- 6459,6464 ----
***************
*** 6289,6298 ****
  	  if (GET_CODE (insn) == JUMP_INSN)
  	    abort ();
  
! 	  if (reload_when_needed[j] == RELOAD_OTHER)
! 	    start_sequence ();
! 	  else
! 	    push_to_sequence (output_reload_insns[reload_opnum[j]]);
  
  	  /* Determine the mode to reload in.
  	     See comments above (for input reloading).  */
--- 6478,6484 ----
  	  if (GET_CODE (insn) == JUMP_INSN)
  	    abort ();
  
! 	  push_to_sequence (output_reload_insns[reload_opnum[j]]);
  
  	  /* Determine the mode to reload in.
  	     See comments above (for input reloading).  */
***************
*** 6358,6380 ****
  			{
  			  rtx third_reloadreg
  			    = reload_reg_rtx[reload_secondary_out_reload[secondary_reload]];
- 			  rtx tem;
  
  			  /* Copy primary reload reg to secondary reload reg.
  			     (Note that these have been swapped above, then
  			     secondary reload reg to OLD using our insn.  */
  
- 			  /* If REAL_OLD is a paradoxical SUBREG, remove it
- 			     and try to put the opposite SUBREG on
- 			     RELOADREG.  */
- 			  if (GET_CODE (real_old) == SUBREG
- 			      && (GET_MODE_SIZE (GET_MODE (real_old))
- 				  > GET_MODE_SIZE (GET_MODE (SUBREG_REG (real_old))))
- 			      && 0 != (tem = gen_lowpart_common
- 				       (GET_MODE (SUBREG_REG (real_old)),
- 					reloadreg)))
- 			    real_old = SUBREG_REG (real_old), reloadreg = tem;
- 
  			  gen_reload (reloadreg, second_reloadreg,
  				      reload_opnum[j], reload_when_needed[j]);
  			  emit_insn ((GEN_FCN (tertiary_icode)
--- 6544,6554 ----
***************
*** 6392,6402 ****
--- 6566,6612 ----
  		}
  	    }
  #endif
+ 	/* PROBLEM: supposed to be intel code here, but too much has
+ 	  changed above, I don't know how it maps */
  
  	  /* Output the last reload insn.  */
  	  if (! special)
+ /*
  	    gen_reload (old, reloadreg, reload_opnum[j],
  			reload_when_needed[j]);
+ */
+ 		{
+ 			emit_insn(gen_move_insn(old,reloadreg));
+  /* intel1 */ if ((flag_loop_after_global || flag_peep_spills)
+               && is_a_reload_stack_slot (old, &indx, cur_stack_offset, NULL))
+               {
+                   reload_insn = get_last_insn ();
+                   RTX_IS_SPILL_P ( reload_insn) = 1;
+                   if (indx == -1)
+                   {
+                      tmp_stack_slot = eliminate_regs (
+                             reg_equiv_memory_loc[REGNO (old)],
+                             GET_MODE (old), NULL_RTX);
+ 
+                     if (num_reload_stack_slots < MAX_RELOAD_STACK_SLOTS
+                        && !is_a_reload_stack_slot (tmp_stack_slot, &indx,
+ 						 cur_stack_offset, NULL))
+                     {
+                       reload_slots[num_reload_stack_slots].cur_stack_offset
+                                 = cur_stack_offset;
+                       reload_slots[num_reload_stack_slots].stack_slot_pseudo_reg
+                                 = REGNO (old);
+                       reload_slots[num_reload_stack_slots].reload_stack_slot
+                                 = tmp_stack_slot;
+                       reload_slots[num_reload_stack_slots++].reload_insn = NULL;
+                     }
+                   SPILL_PSEUDO (reload_insn) = REGNO (old);
+                  } else
+                     SPILL_PSEUDO (reload_insn)
+                          = reload_slots[indx].stack_slot_pseudo_reg;
+                }
+             }
+ 
  
  #ifdef PRESERVE_DEATH_INFO_REGNO_P
  	  /* If final will look at death notes for this reg,
***************
*** 6436,6450 ****
  		  new_spill_reg_store[reload_spill_index[j]] = p;
  	      }
  
! 	  if (reload_when_needed[j] == RELOAD_OTHER)
! 	    {
! 	      if (other_output_reload_insns)
! 		emit_insns (other_output_reload_insns);
! 	      other_output_reload_insns = get_insns ();
! 	    }
! 	  else
! 	    output_reload_insns[reload_opnum[j]] = get_insns ();
! 
  	  end_sequence ();
  	}
      }
--- 6646,6652 ----
  		  new_spill_reg_store[reload_spill_index[j]] = p;
  	      }
  
! 	  output_reload_insns[reload_opnum[j]] = get_insns ();
  	  end_sequence ();
  	}
      }
***************
*** 6455,6461 ****
  
       RELOAD_FOR_OTHER_ADDRESS reloads for input addresses.
  
!      RELOAD_OTHER reloads, output in ascending order by reload number.
  
       For each operand, any RELOAD_FOR_INPUT_ADDRESS reloads followed by
       the RELOAD_FOR_INPUT reload for the operand.
--- 6657,6663 ----
  
       RELOAD_FOR_OTHER_ADDRESS reloads for input addresses.
  
!      RELOAD_OTHER reloads.
  
       For each operand, any RELOAD_FOR_INPUT_ADDRESS reloads followed by
       the RELOAD_FOR_INPUT reload for the operand.
***************
*** 6467,6476 ****
       After the insn being reloaded, we write the following:
  
       For each operand, any RELOAD_FOR_OUTPUT_ADDRESS reload followed by
!      the RELOAD_FOR_OUTPUT reload for that operand.
! 
!      Any RELOAD_OTHER output reloads, output in descending order by
!      reload number.  */
  
    emit_insns_before (other_input_address_reload_insns, before_insn);
    emit_insns_before (other_input_reload_insns, before_insn);
--- 6669,6675 ----
       After the insn being reloaded, we write the following:
  
       For each operand, any RELOAD_FOR_OUTPUT_ADDRESS reload followed by
!      the RELOAD_FOR_OUTPUT reload for that operand.  */
  
    emit_insns_before (other_input_address_reload_insns, before_insn);
    emit_insns_before (other_input_reload_insns, before_insn);
***************
*** 6490,6497 ****
        emit_insns_before (output_reload_insns[j], following_insn);
      }
  
-   emit_insns_before (other_output_reload_insns, following_insn);
- 
    /* Move death notes from INSN
       to output-operand-address and output reload insns.  */
  #ifdef PRESERVE_DEATH_INFO_REGNO_P
--- 6689,6694 ----
***************
*** 6691,6696 ****
--- 6888,6895 ----
       int opnum;
       enum reload_type type;
  {
+   /* intel1 */
+   int indx;
    rtx last = get_last_insn ();
    rtx tem;
  
***************
*** 6858,6864 ****
--- 7057,7080 ----
  
    /* If IN is a simple operand, use gen_move_insn.  */
    else if (GET_RTX_CLASS (GET_CODE (in)) == 'o' || GET_CODE (in) == SUBREG)
+   {
      emit_insn (gen_move_insn (out, in));
+     if ((flag_loop_after_global || flag_peep_spills)   /* intel1 */
+       && is_a_reload_stack_slot (in, &indx, cur_stack_offset, get_last_insn()))
+       {
+         rtx reload_insn = get_last_insn ();
+ 
+   RTX_IS_SPILL_P ( reload_insn) = 1;
+   if (indx == -1)
+      {
+            SPILL_PSEUDO (reload_insn) = REGNO (in);
+      }
+   else
+      SPILL_PSEUDO (reload_insn)
+         = reload_slots[indx].stack_slot_pseudo_reg;
+       }
+   }
+ 
  
  #ifdef HAVE_reload_load_address
    else if (HAVE_reload_load_address)
